/*
 *	PostgreSQL type definitions for Password generator
 *
 *	$PostgreSQL: pgsql/contrib/passgen/passgen.c $
 */

#include "postgres.h"
#include "fmgr.h"
#include "utils/builtins.h"
#include <ctype.h>
#include <stdio.h> 
#include <stdlib.h>
#include <time.h>


#ifdef PG_MODULE_MAGIC
PG_MODULE_MAGIC;
#endif

PG_FUNCTION_INFO_V1(passgen);

char *passbuild(int,int);
Datum * passgen(PG_FUNCTION_ARGS);


char * passbuild(int length,int id)
{
  int i,r;
  char *s,*p;
 
  s=(char*) palloc (sizeof(*s)*length+1); 
  p=s;
  srand((unsigned int)time(0)*id);
  i=length;
  while (i > 0){
    r = rand()%128;
    if ((r>=48 && r<=57)||(r>=65 && r<=90)||(r>=97 && r<122)){
      *s = (char)r;
      s++; i--;
    }
  }
  *s='\0';
  return p;
}


Datum * passgen(PG_FUNCTION_ARGS)
{
  int length,id;
  char *p;
  text *rst;
  
  length = PG_GETARG_INT16(0);
  id = PG_GETARG_INT16(1); 

  /* Fine reperimento parametri */
  p = passbuild(length,id);
  rst = DatumGetTextP(DirectFunctionCall1(textin,CStringGetDatum(p)));
  PG_RETURN_TEXT_P(rst);
}




